djinn-lib-0.0.1.2: Generate Haskell code from a type. Library extracted from djinn package.

Safe Haskell | Safe
Language | Haskell98

Djinn.LJTFormula

# Documentation

newtype Symbol Source

Constructors

Symbol String |

Instances

Eq Symbol Source |
Ord Symbol Source |
Show Symbol Source |

data Formula Source

Constructors

Conj [Formula] |
Disj [(ConsDesc, Formula)] |
Formula :-> Formula infixr 2 |
PVar Symbol |

Instances

Eq Formula Source |
Ord Formula Source |
Show Formula Source |

(<->) :: Formula -> Formula -> Formula infix 2 Source

(&) :: Formula -> Formula -> Formula infixl 4 Source

(|:) :: Formula -> Formula -> Formula infixl 3 Source

fnot :: Formula -> Formula Source

false :: Formula Source

true :: Formula Source

data ConsDesc Source

Constructors

ConsDesc String Int |

Instances

Eq ConsDesc Source |
Ord ConsDesc Source |
Show ConsDesc Source |

data Term Source

Constructors

Var Symbol |
Lam Symbol Term |
Apply Term Term |
Ctuple Int |
Csplit Int |
Cinj ConsDesc Int |
Ccases [ConsDesc] |
Xsel Int Int Term |

Instances

Eq Term Source |
Ord Term Source |
Show Term Source |

applys :: Term -> [Term] -> Term Source

freeVars :: Term -> [Symbol] Source